// Paket mit bergeordneter Klasse fr die Darstellung am
// Bildschirm in Parallelprojektion
// Implementation
// (c) 1996 by Andreas Meile, HTL Brugg-Windisch
// Klasse 3 Ia  Datum: 29.11.1996

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
#include <conio.h>
#include "eing_rou.h"
#include "lib3d.h"

vektor3d ex(1.0, 0.0, 0.0), ey(0.0, 1.0, 0.0), ez(0.0, 0.0, 1.0);
const float pi = ldexp(atan(1.0), 2);

// Effektiv verwendete Limiten beim Context-Blitten
int x_eff_min, x_eff_max, y_eff_min, y_eff_max,

    alter_videomodus; // Zwischenspeicher fr die Kennung des Videomodus
                      // beim Aufruf

void grafikmodus_ein(int hg, int vg) {
  int treiber_konst = GR_width_height_color_graphics, // Hardware-Konstante
  // fr Grafikaktivierung; falls mit lterem Treiber ohne Explizit-Modus-
  // angabe gearbeitet wird, muss vom Benutzer ein anderer Wert eingegeben
  // werden
  x_aufl = 640,  // horizontale Grafikauflsung
  y_aufl,        // vertikale Grafikauflsung
  a_far = 16;    // Anzahl Farben

  printf("\nSie knnen sich die Grafikauflsung selber aussuchen!\n");
  
  printf("Wichtiger Hinweis: ltere Grafiktreiber knnen Sie nur ber die\n"
  "Treiberkonstante ansteuern, ndern Sie diese daher nur ab, falls auf\n"
  "Ihrem System die Direkt-Videomoduswahl nicht korrekt luft.\n\n");
  lies_interv_ganze_zahl("Grafiktreiberkonstante Ihres Systems", "/",
  GR_320_200_graphics, GR_width_height_color_graphics, &treiber_konst);
  
  lies_positive_zahl("Horizontale Auflsung (Anzahl Bildpunkte)", "/",
  &x_aufl);
  y_aufl = ((x_aufl+1) * 3) >> 2;

  lies_positive_zahl("Vertikale Auflsung (Anzahl Bildpunkte)", "/",
  &y_aufl);
  lies_positive_zahl("Anzahl Farben (log2(Eingabe) ganzzahlig)", "/",
  &a_far);

  alter_videomodus = GrCurrentMode();
  GrSetMode(treiber_konst, x_aufl, y_aufl, a_far);
  GrClearScreen(hg);
}

void grafikmodus_aus() {
  GrSetMode(alter_videomodus);
}

int grafik_max_x() {
  return GrMaxX();
}

int grafik_max_y() {
  return GrMaxY();
}

// Privat-Prozedur fr Bildschirmaktualisierung
void szene3d::aktual_neuzeichnen() { // Hintergrundfarbe als
  // Parameter
  // Zuerst Transformationsparameter bilden
  vektor3d transx, transy, transz; // Transformationsvektoren
  // transz wird nur fr das Sortieren bentigt
  float ox, oy;           // Verschiebebetrag
  int x_t_min = xmax,     // kleinste, effektiv verwendete X-Koordinate
      x_t_max = 0,        // grsste, effektiv verwendete X-Koordinate
      y_t_min = ymax,     // kleinste, effektiv verwendete Y-Koordinate
      y_t_max = 0;        // grsste, effektiv verwendete Y-Koordinate
  transx.x = xf * ev[0].x;         // T^-1 d.h. T^T verwenden
  transx.y = xf * ev[1].x;
  transx.z = xf * ev[2].x;
  transy.x = -yf * ev[0].y;
  transy.y = -yf * ev[1].y;
  transy.z = -yf * ev[2].y;
  transz.x = ev[0].z;
  transz.y = ev[1].z;
  transz.z = ev[2].z;

  ox = xmb - transx * mr;
  oy = ymb - transy * mr;
  // Koordinaten-Transformation inkl. z-Sortierung durchfhren
  for(register int i=0; i<n_obj; i++) {
    objekt3d *akt_obj = sortfeld[i].obj; // Zeiger herausnehmen
    sortfeld[i].z = akt_obj->m * transz;
    if(akt_obj->typ != kugel) {
      // Umrechnung der Punkte von 3D nach 2D
      for(register int j=0; j<akt_obj->n_kno; j++) {
        register int x = int(transx * akt_obj->pkt[j] + ox),
                     y = int(transy * akt_obj->pkt[j] + oy);
        akt_obj->bxy[j][0] = x;
        akt_obj->bxy[j][1] = y;
        // Aktualisierung der Limiten
        if(x < x_t_min)
          x_t_min = x;
        if(x > x_t_max)
          x_t_max = x;
        if(y < y_t_min)
          y_t_min = y;
        if(y > y_t_max)
          y_t_max = y;
      }
    }
    // Einfacher Bubble-Sort
    for(register int j=0; j<i; j++) {
      if(sortfeld[i].z < sortfeld[j].z) {
        {
          register float temp_z = sortfeld[i].z;
          sortfeld[i].z = sortfeld[j].z;
          sortfeld[j].z = temp_z;
        }
        {
          register objekt3d *temp_obj = sortfeld[i].obj;
          sortfeld[i].obj = sortfeld[j].obj;
          sortfeld[j].obj = temp_obj;
        }
      }
    }
  }
  // Nun zeichnen
  GrSetContext(puff);
  // Lschen des wirklich bentigten Ausschnittes mit einem Rechteck
  // => schneller als Hunderte von KBytes mit GrClearContext(hg) lschen
  GrFilledBox(x_eff_min, y_eff_min, x_eff_max, y_eff_max, hg);
  for(i=0; i < n_obj; i++) {
    objekt3d *akt_obj = sortfeld[i].obj;
    if(akt_obj->typ == kugel) {
      int rx = int(xf * akt_obj->pkt[0].x),
          ry = int(yf * akt_obj->pkt[0].x),
          xm = int(transx * akt_obj->m + ox),
          ym = int(transy * akt_obj->m + oy);
      GrFilledEllipse(xm, ym, rx, ry, akt_obj->ff);
      GrEllipse(xm, ym, rx, ry, akt_obj->uf);
      // Aktualisierung der Limiten
      if(xm - rx < x_t_min)
        x_t_min = xm - rx;
      if(xm + rx > x_t_max)
        x_t_max = xm + rx;
      if(ym - ry < y_t_min)
        y_t_min = ym - ry;
      if(ym + ry > y_t_max)
        y_t_max = ym + ry;
    } else {
      int *p1 = akt_obj->zdef, *p_end = p1 + akt_obj->n_zdef;
      int_pt *p2;
      while(p1 < p_end) {
        int n = *p1;
        p1++;
        if(*p1 == -1) {
          p2 = akt_obj->bxy + p1[1];
          p1 += 2;
        } else {
          for(register int k=0; k<n; k++) {
            b_koord[k][0] = akt_obj->bxy[*p1][0];
            b_koord[k][1] = akt_obj->bxy[*p1][1];
            p1++;
          }
          p2 = b_koord;
        }
        if(akt_obj->typ == drahtm)
          GrPolyLine(n, p2, akt_obj->uf);
        else if((p2[2][0] - p2[0][0]) * (p2[1][1] - p2[0][1]) <
          (p2[1][0] - p2[0][0]) * (p2[2][1] - p2[0][1])) { // Sichtbar?
          // => Test mit Kreuzprodukt (hier optimierte Abkrzung davon)
          GrFilledConvexPolygon(n, p2, akt_obj->ff);
          GrPolygon(n, p2, akt_obj->uf);
        }
      }
    }
  }
  GrSetContext(NULL);
  // Begrenzen auf Context-Ausschnitt
  if(x_t_min < 0)
    x_t_min = 0;
  if(x_t_max > xmax)
    x_t_max = xmax;
  if(y_t_min < 0)
    y_t_min = 0;
  if(y_t_max > ymax)
    y_t_max = ymax;
  // Zu bertragen ist nur dasjenige Rechteck, welches sowohl den vorherigen
  // Ausschnitt (Lschen!) und den neuen Ausschnitt berdeckt
  GrBitBlt(NULL, xpos + (x_t_min < x_eff_min ? x_t_min : x_eff_min),
                 ypos + (y_t_min < y_eff_min ? y_t_min : y_eff_min),
           puff, x_t_min < x_eff_min ? x_t_min : x_eff_min,
                 y_t_min < y_eff_min ? y_t_min : y_eff_min,
                 x_t_max > x_eff_max ? x_t_max : x_eff_max,
                 y_t_max > y_eff_max ? y_t_max : y_eff_max, GrWRITE);
  x_eff_min = x_t_min;
  x_eff_max = x_t_max;
  y_eff_min = y_t_min;
  y_eff_max = y_t_max;
}

// Konstruktor
szene3d::szene3d() {
  n_obj = 0;
  erst = NULL;   // Anfnglich noch kein Objekt
  max_pts = 0;   // auch noch keine Kurvenzge
  puff = NULL;   // Alle Pointers auf Null
  sortfeld = NULL;
}

// Destruktor
szene3d::~szene3d () {
  if(puff != NULL)  // Noch nicht vom Bildschirm entfernt?
    this->entferne_am_bildschirm();
  // Nun schn der Reihe nach alles wieder freigeben
  objekt3d *i = erst;
  while(i != NULL) {
    objekt3d *j = i->naechst; // Zeiger sichern
    delete [] i->bxy;   // Bildschirmkoordinatenpuffer lschen
    delete [] i->pkt;   // Knotenfeld lschen
    delete [] i->zdef; // Verbindungsinformationsfeld lschen
    delete i; // Objekt-Record selber freigeben
    i = j;
  }
  // erst = NULL; max_pts = 0; n_obj = 0; msste man noch machen, falls
  // das Objekt weiter gebraucht wrde
}

void szene3d::neues_objekt(int n_knot, int n_kdefi, const vektor3d &mi,
int umr_far, int f_far, obj_typ o_art) {
  objekt3d *i = erst;  // Abhngen
  erst = new objekt3d; // und neues Objekt in die
  erst->naechst = i;   // Kette direkt einfgen
  n_obj++;
  erst->uf = umr_far;
  erst->ff = f_far;
  erst->typ = o_art;
  erst->m = mi;
  erst->n_kno_max = n_knot; // Knotenspeicher anlegen
  erst->n_kno = 0;
  erst->pkt = new vektor3d[n_knot];
  erst->bxy = new int_pt[n_knot];
  erst->n_zdef_max = n_kdefi; // Kurvenzugdefinitionsspeicher anlegen
  erst->n_zdef = 0;
  erst->zdef = new int[n_kdefi];
}

int szene3d::fuege_knoten_ein(const vektor3d &p) {
  if(erst->n_kno == erst->n_kno_max)  // Kein Platz mehr frei
    return -1;
  else {
    register int i=erst->n_kno;
    erst->pkt[i] = p;
    erst->n_kno++;
    return i;
  }
}

int szene3d::fuege_k_zug_ein(int pnr[]) {
  register int i = erst->n_zdef, n = (pnr[1] == -1 ? 3 : pnr[0] + 1);

  if(pnr[1] != -1 && n - 1 > max_pts)
    max_pts = n - 1;

  if(i + n > erst->n_zdef_max) // Kein Platz mehr
    return -1;
  else {
    for(register int j=0; j<n; j++) {
      erst->zdef[i] = pnr[j];
      i++;
    }
    erst->n_zdef = i;
    return 0;
  }
}

void szene3d::aktualisiere_mittelpunkt() {  // Mittelpunkt aktualisieren
  vektor3d s(0.0, 0.0, 0.0); // Summenvektor zu Beginn = 0
  register vektor3d *j = erst->pkt;
  for(register int i = erst->n_kno; i; i--) {
    s += *j;
    j++;
  }
  erst->m = s / float(erst->n_kno);
}

void szene3d::fuege_kugel_ein(const vektor3d &z, float r, int umr_far,
int f_far) {
  this->neues_objekt(1, 1, z, umr_far, f_far, kugel);
  vektor3d v(r); // Hilfsvektor, um in der x-Komponente den Radius speichern
  this->fuege_knoten_ein(v);
}

void szene3d::fuege_pyramide_ein(const vektor3d &s, vektor3d &k, vektor3d &m,
int n_ecken, int umr_far, int f_far) {
  const float schritt = ldexp(pi, 1) / float(n_ecken);
  int k_defs[6];
  
  this->neues_objekt(1 + n_ecken, f_far != -1 ? n_ecken << 2 | 3 // en. 4*n+3
  : 3 * n_ecken + (n_ecken & 1), (0.6 * (m * k) / (m * m)) * m + s, umr_far,
  f_far, f_far != -1 ? polyeder : drahtm);
  this->fuege_knoten_ein(s); // Spitze einfgen
  for (register int i=0; i<n_ecken; i++)
    fuege_knoten_ein(k.gedreht(m, float(i) * schritt) + s);

  if(f_far != -1) {  // Vollkrper
    // Boden
    k_defs[0] = n_ecken;
    k_defs[1] = -1;
    k_defs[2] = 1;
    fuege_k_zug_ein(k_defs);
    // Seitenflchen
    k_defs[0] = 3;
    k_defs[1] = 0;
    k_defs[2] = n_ecken;
    for (i=1; i<=n_ecken; i++) {
      k_defs[3] = k_defs[2];
      k_defs[2] = i;
      fuege_k_zug_ein(k_defs);
    }
  } else { // Drahtmodell
    k_defs[5] = n_ecken;
    k_defs[3] = 0;
    for(i=1; i<=n_ecken; i+=2) {
      k_defs[0] = (i == n_ecken ? 3 : 5);
      k_defs[1] = i;
      k_defs[2] = k_defs[5];
      k_defs[4] = i;
      k_defs[5] = i+1;
      fuege_k_zug_ein(k_defs);
    }
  }
}

void szene3d::fuege_prisma_ein(const vektor3d &s, vektor3d &m, vektor3d &r,
int n_ecken, int umr_far, int f_far) {
  const float schritt = ldexp(pi, 1) / float(n_ecken);
  int k_defs[5];
  
  this->neues_objekt(n_ecken << 1, f_far != -1 ? 5 * n_ecken + 6 :
  5 * n_ecken, m * ((m * r) / (m * m) + 0.5) + s, umr_far, f_far,
  f_far != -1 ? polyeder : drahtm);
  
  // Beide Seitenflchen gegenlufig einfgen
  for (register int i=0; i<n_ecken; i++)
    fuege_knoten_ein(r.gedreht(m, float(~i) * schritt) + s); // Boden
  for (i=0; i<n_ecken; i++)
    fuege_knoten_ein(r.gedreht(m, float(i) * schritt) + m + s); // Deckel

  if(f_far != -1) {  // Vollkrper
    // Boden
    k_defs[0] = n_ecken;
    k_defs[1] = -1;
    k_defs[2] = 0;
    fuege_k_zug_ein(k_defs);
    // Deckel
    k_defs[2] = n_ecken;
    fuege_k_zug_ein(k_defs);
  }
  // Seitenflchen : identisch beim Drahtmodell
  k_defs[0] = 4;
  k_defs[1] = n_ecken - 1;
  k_defs[4] = n_ecken;
  for (i=0; i<n_ecken; i++) {
    k_defs[2] = k_defs[1];
    k_defs[3] = k_defs[4];
    k_defs[1] = i;
    k_defs[4] = (n_ecken << 1)- 1 - i;
    fuege_k_zug_ein(k_defs);
  }
}    
  
void szene3d::fuege_parallelepiped_ein(vektor3d &s, vektor3d &k1,
const vektor3d &k2, const vektor3d &k3, int umr_far, int f_far) {
  int k_defs[5] = {4, 4, 7, 1, 0};
  
  this->neues_objekt(8, f_far != -1 ? 26 : 20, (k1 + k2 + k3) / 2.0 + s,
  umr_far, f_far, f_far != -1 ? polyeder : drahtm);
  // Alle 8 Knoten
  fuege_knoten_ein(s);
  fuege_knoten_ein(s + k1);
  fuege_knoten_ein(s + k1 + k2);
  fuege_knoten_ein(s + k2);
  fuege_knoten_ein(s + k3);
  fuege_knoten_ein(s + k3 + k2);
  fuege_knoten_ein(s + k3 + k1 + k2);
  fuege_knoten_ein(s + k3 + k1);

  // Seiten: Identisch mit Drahtmodell
  fuege_k_zug_ein(k_defs);
  k_defs[1] = 7;
  k_defs[2] = 6;
  k_defs[3] = 2;
  k_defs[4] = 1;
  fuege_k_zug_ein(k_defs);
  k_defs[1] = 6;
  k_defs[2] = 5;
  k_defs[3] = 3;
  k_defs[4] = 2;
  fuege_k_zug_ein(k_defs);
  k_defs[1] = 5;
  k_defs[2] = 4;
  k_defs[3] = 0;
  k_defs[4] = 3;
  fuege_k_zug_ein(k_defs);
  if(f_far != -1) {
    k_defs[1] = -1;
    fuege_k_zug_ein(k_defs);
    k_defs[2] = 0;
    fuege_k_zug_ein(k_defs);
  }
}

void szene3d::fuege_tetraeder_ein(vektor3d &e1, const vektor3d &e2,
const vektor3d &e3, const vektor3d &e4, int umr_far, int f_far) {
  int k_defs[4] = {3, 0, 3, 2};

  this->neues_objekt(4, f_far != -1 ? 15 : 12, (e1 + e2 + e3 + e4)/4.0,
  umr_far, f_far, f_far != -1 ? polyeder : drahtm);

  // Alle 8 Knoten
  fuege_knoten_ein(e1);
  fuege_knoten_ein(e2);
  fuege_knoten_ein(e3);
  fuege_knoten_ein(e4);
  // Seitenflchen: Mit Drahtmodell identisch
  fuege_k_zug_ein(k_defs);
  k_defs[2] = 2;
  k_defs[3] = 1;
  fuege_k_zug_ein(k_defs);
  k_defs[2] = 1;
  k_defs[3] = 3;
  fuege_k_zug_ein(k_defs);
  if(f_far != -1) { // Boden beim Flchenmodell
    k_defs[1] = -1;
    fuege_k_zug_ein(k_defs);
  }
}

void szene3d::zeige_an(const vektor3d &mitte, float bx, float by,
int h_grund, int bxmin, int bxmax, int bymin, int bymax) {
  hg = h_grund;
  xpos = bxmin;
  ypos = bymin;
  xmax = bxmax - bxmin;
  ymax = bymax - bymin;
  
  // Ansichtsausschnitt vorbereiten
  // Pixelverhltniskonstante
  const float y_x_pix_verh = float(GrScreenY() << 2) / float(3 * GrScreenX());

  xf = float(xmax) / bx;
  yf = float(ymax) / by;
  // Faktoren ausproportionieren, um eine verzerrte Darstellung zu vermeiden
  if(xf * y_x_pix_verh > yf)
    xf = yf / y_x_pix_verh;
  else
    yf = xf * y_x_pix_verh;
  xmb = ldexp(float(xmax), -1);
  ymb = ldexp(float(ymax), -1);
  mr = mitte;

  // Dynamische Hilfsvariablen und Grafik-Context vorbereiten
  puff = GrCreateContext(xmax + 1, ymax + 1, NULL, NULL);
  // Am Anfang alles lschen
  x_eff_min = 0; x_eff_max = xmax;
  y_eff_min = 0; y_eff_max = ymax;
  sortfeld = new z_sor_ptr[n_obj];
  {
    register int i=0;
    register objekt3d *j=erst;
    while(j != NULL) {
      sortfeld[i].obj = j;
      i++;
      j = j->naechst;
    }
  }
  b_koord = new int_pt[max_pts];
  
  this -> reset();  // Einheitsmatrix zuweisen
}

// Anzeige am Bildschirm wieder rckgngig machen
// => Freigabe des Grafik-Contexts und des Sortier-Arrays
void szene3d::entferne_am_bildschirm() {
  // Bildschirmflche lschen (mit Hintergrundfarbe)
  GrFilledBox(xpos + x_eff_min, ypos + y_eff_min, xpos + x_eff_max,
  ypos + y_eff_max, hg); // Nur effektiv benutzter Ausschnitt
  delete [] sortfeld;
  sortfeld = NULL;
  delete [] b_koord;
  b_koord = NULL;
  GrDestroyContext(puff);
  puff = NULL;
}

void szene3d::reset() {  // Zurcksetzen des Blickwinkels auf die
  // Einheitsmatrix
  ev[0] = ex;
  ev[1] = ey;
  ev[2] = ez;
  this -> aktual_neuzeichnen();
}

void szene3d::korrektur() { // Rundungsfehler-Korrektur
  ev[0] = ev[0].einheit();
  ev[1] = ev[1] - ((ev[1] * ev[0]) / (ev[0] * ev[0])) * ev[0];
  ev[1] = ev[1].einheit();
  ev[2] = kreuzp(ev[0], ev[1]);
  this -> aktual_neuzeichnen();
}

void szene3d::drehen(vektor3d &achse, float w) {
  for(register int i=0; i<3; i++) {
    ev[i] = ev[i].gedreht(achse, w);
  }
  this -> aktual_neuzeichnen();
}

void szene3d::zoom_in(float f) {
  xf *= f;
  yf *= f;
  this -> aktual_neuzeichnen();
}

int szene3d::dyn_drehen() {
  const float w_schritt = 0.08; // 0.08 rad  5
  const float zoom_schritt = 1.05; // Zoom In/Out-Schrittweite

  int t_druck = getch(); // Tastendruck
  if(t_druck == 0)
    t_druck = getch() | 0x100; // 256 dazuzhlen => Sondertaste
  switch(t_druck) {
    case 0x100 | 'H' :
      this -> drehen(ex, w_schritt);
      break;
    case 0x100 | 'P' :
      this -> drehen(ex, -w_schritt);
      break;
    case 0x100 | 'K' :
      this -> drehen(ey, w_schritt);
      break;
    case 0x100 | 'M' :
      this -> drehen(ey, -w_schritt);
      break;
    case 0x100 | 'I' :
      this -> drehen(ez, -w_schritt);
      break;
    case 0x100 | 'Q' :
      this -> drehen(ez, w_schritt);
      break;
    case '+' :  // Hineinzoomen
      this -> zoom_in(zoom_schritt);
      break;
    case '-' :  // Herauszoomen
      this -> zoom_in(1.0 / zoom_schritt);
      break;
    case 'k' : // Korrektur
    case 'K' :
      this -> korrektur();
      break;
    case 'r' : // Zurcksetzen der Ansicht
    case 'R' :
      this -> reset();
      break;
    case 'd' : // Hbsche Demo!
    case 'D' : // Ideal fr's Schaufenster...
      {
        const int n_gl_w = 16; // Anzahl Glttwerte
        const int verkl = 11; // Damit keine berlufe beim Rechnen mit
        // der Uhr auftreten, werden alle Zeiten um 2^11 verkleinert
        
        const float umr = float(CLOCKS_PER_SEC) * float(n_gl_w *
        (n_gl_w + 1)) / float(1 << verkl + 1);

        // Drehgeschwindigkeit der Achsen fr Animation, gesteuert von
        // der Systemuhr, der Zhler ist direkt in rad/s => gerteunabhngig
        const float omega_rot_achse = 0.43 / umr;
        const float omega_koerper = 1.0 / umr;
        const float tempo_schritt = 1.2; // Schritt fr [+]/[-]-Funktion

        // Da die Systemuhr die Zeit lediglich nur mit 2^16 Ticks pro Stunde
        // auflst, wird hier mit einem speziellen Zeitglttungsverfahren
        // gearbeitet: Die aktuelle Zeit wird nach einer Formel (z.B. fr
        // 16 Werte) t_gltt = 16*t[n] + 15*t[n-1] + 14*t[n-2] + ... t[t-15]
        // berechnet und durch 136 (=16+15+14+..+1) dividiert (in der
        // Geschwindigkeitskonstante enthalten

        clock_t akt_zeit, letzt_zeit, // bereits geglttete Zeit
                t_puff[n_gl_w];       // Speicher mit den letzten Zeiten

        vektor3d r_achse(1.0, 0.0, 0.0); // Startlage der Achse

        float omega_r_a = omega_rot_achse,
              omega_koe = omega_koerper;
        
        int drinbleiben = 1, puff_zyklus = 0;
        register int i;               // Zhler

        for(i=0; i<n_gl_w; i++)
          t_puff[i] = clock() >> verkl;
        letzt_zeit = n_gl_w * (n_gl_w + 1) * (clock() >> verkl + 1);

        while(drinbleiben) {
          do {
            t_puff[puff_zyklus] = clock() >> verkl;
            akt_zeit = 0;
            for(i=n_gl_w; i>0; i--)
              akt_zeit += i * t_puff[puff_zyklus + i & n_gl_w - 1];

            register float delta_clock = float(akt_zeit - letzt_zeit);
            r_achse = r_achse.gedreht(ez, omega_r_a * delta_clock);
            this -> drehen(r_achse, omega_koe * delta_clock);
            puff_zyklus++;
            puff_zyklus &= n_gl_w - 1;
            letzt_zeit = akt_zeit;
          } while (!kbhit());
          t_druck = getch();
          if(t_druck == 0)
            t_druck = getch() | 0x100;
          switch(t_druck) {
            case '+':
              omega_r_a *= tempo_schritt;
              omega_koe *= tempo_schritt;
              break;
            case '-':
              omega_r_a /= tempo_schritt;
              omega_koe /= tempo_schritt;
              break;
            default:
              drinbleiben = 0;
          }
        }
      }
  }
  return t_druck;
}
