// Kleines Paket mit Vektorroutinen fr 3D-Berechnung
// als Klasse definiert, Spezifikationen
// (c) 1996 by Andreas Meile, HTL Brugg-Windisch
// Datum: 18.11.1996  Klasse 3 Ia

#ifndef vektor3d_h
#define vektor3d_h

class vektor3d {
  public:
    float x,   // x-Koordinate
          y,   // y-Koordinate
          z;   // z-Koordinate
    vektor3d (float xk=0.0, float yk = 0.0, float zk = 0.0); // Konstruktor
    vektor3d & operator= (const vektor3d &v); // Zuweisung
    vektor3d operator+ (const vektor3d &v);
    vektor3d operator- (const vektor3d &v);
    vektor3d operator- ();  // unre Version
    vektor3d operator* (float skalar);
    friend vektor3d operator* (float skalar, const vektor3d &v);
    // Division mit Skalar
    vektor3d operator/ (float skalar);
    // Skalarprodukt
    float operator* (const vektor3d &v);
    // C-spezifische Kurzoperatoren
    vektor3d & operator+= (const vektor3d &v);
    vektor3d & operator-= (const vektor3d &v);
    vektor3d & operator*= (float skalar);
    vektor3d & operator/= (float skalar);

    friend vektor3d kreuzp(const vektor3d &v1, const vektor3d &v2);
    friend vektor3d ldexp(const vektor3d &v, int p);
    float norm();
    // Einheitsvektor
    vektor3d einheit();
    
    // Geometrische Funktionen
    friend float winkel(vektor3d &v1, vektor3d &v2);
    vektor3d gedreht(vektor3d &a, // Achse (msste eigentlich 'const' sein!)
                     float w);    // Drehwinkel

    // Ausgabe am Bildschirm
    int put();
};

#endif
